function s=ssum(x)
% SSUM Simple (and silly) summation
%
% s=csum(x) returns the sum of all the elements in a vector x.
%
% The algorithm is the simplest possible summation algorithm and is not
% numerically stable.
%
% See also CSUM
%
% Example:
%  x=rand(1e5,1); x=x./ssum(x);
%  fprintf('ssum(x) = %18.16e\n', ssum(x));
%  fprintf(' sum(x) = %18.16e\n', sum(x));
%  fprintf('csum(x) = %18.16e\n', csum(x));


s=0; for i=1:numel(x), s=s+x(i); end
