%% Format the output from the datastats computation

load bvgresults
load matresults

allresults = [bvgresults matresults];

for i=1:length(allresults)
    r=allresults(i);
    r.maxod = full(r.maxod); r.maxid = full(r.maxid);
    r.nzerood = full(r.nzerood); r.nzeroid = full(r.nzeroid);
    n=r.nverts/100; % convert for percentages
    % write out the name and the citation
    fprintf('\\dataname{%s} & %s &\n', r.name, '\cite{needcite}');
    % write out the nverts and nedges
    fprintf('\\np{%i} & \\np{%i} &\n', r.nverts, r.nedges);
    % write out the strong c and max comp size
    fprintf('\\np{%i} & \\np{%i} & \\np{%g} \\%%\n', r.ncomp, r.maxcompsize, r.maxcompsize/n);
    % write degree information
    fprintf('\\np{%i} & \\np{%i} & \\np{%g} \\%%\n', r.maxod, r.nzerood, r.nzerood/n);
    fprintf('\\np{%i} & \\np{%i} & \\np{%g} \\%%\n', r.maxid, r.nzeroid, r.nzeroid/n);
    % write core information
    fprintf('\\np{%i} & \\np{%i} & \\np{%g} \\%% \n', r.maxcorenum, r.onecoresize, r.onecoresize/n);
    fprintf('\\\\\n');
end