%% Setup the experiment
% This experiment should be run from the rapr/experiments/datastats directory
cwd = pwd;
dirtail = 'experiments/density'; 
if strcmp(cwd(end-length(dirtail)+1:end),dirtail) == 0
    warning('rapr:dir','%s should be executed from rapr/%s\n',mfilename,dirtail);
end
addpath('../../matlab'); % ensure we have the RAPr codes available

%% The Beta distribution
% In this experimnt, we'll use the beta distribution.  Using the RAPr
% functions, creating an instance of this distribution for our problem is
% simple.
a=2; b=16; l=0; r=1;
d=alphadist('beta',a,b,l,r); 
eA=d.mf(1); eA=eA(end); % compute the expected value of the Beta variable.

%%
% We'll load a small graph, so we have a tractable number of density
% functions to plot.
load('../../data/example-small.mat');
n=size(P,1);

% choose a value for the number of GQ points, the small graph is 6x6, so
% the polynomial should be of degree 
N=18;

% compute pagerank at each quadrature point and also compute the PageRank
% vector of the exected value.  
[ex stdx xw X] = gqrapr(P,N,d,'direct');
xeA = inoutpr(P,eA);

%% The fast david way...
C=(diag(1./stdx)*X)*diag(xw(:,2))*(diag(1./stdx)*X)';
C=Dxixj-(ex./stdx)*(ex./stdx)';

%% The slow paul way...
exixj=zeros(n,n);
for i=1:n, for j=1:n, for k=1:N,
         exixj(i,j)=exixj(i,j) + X(i,k)*X(j,k)*xw(k,2)/(stdx(i)*stdx(j));
end, end, end
covX = exixj-(ex./stdx)*(ex./stdx)';