%% Compute the solution time for the uk-2006 graph
% I mistakenly forgot to run the random solves for uk-2006 with the time
% command.  However, we can infer the time by looking at the write times
% between the .xw file and the .mean file.
%
% These data were captured on 27 Feb 2008

% This experiment should be run from the rapr/experiments/uk-spam-2006 directory
cwd = pwd;
dirtail = 'experiments/uk-spam-2006'; 
if strcmp(cwd(end-length(dirtail)+1:end),dirtail) == 0
    error('rapr:dir','%s must be executed from rapr/%s\n',mfilename,dirtail);
end
addpath('../tools');
addpath('../../matlab');

!ls -l

beta_2_16_start = '2008-02-19 00:03';
beta_2_16_end = '2008-02-23 07:22';

beta_1_1_start = '2008-02-23 07:22';
beta_1_1_end = '2008-02-24 09:31';

dt_2_16 = etime(datevec(datenum(beta_2_16_end)),datevec(datenum(beta_2_16_start)));
dt_1_1 = etime(datevec(datenum(beta_1_1_end)),datevec(datenum(beta_1_1_start)));

fprintf('The 25-point beta(2,16) solve took %.1f min\n', dt_2_16/60);
fprintf('The 10-point beta(1,1) solve took %.1f min\n', dt_1_1/60);

% When written, this outputted 
% 
%  The 25-point beta(2,16) solve took 6199.0 min
%  The 10-point beta(1,1) solve took 1569.0 min
%