
%% Setup the computation
global datadir;
if isempty(datadir), datadir='../data'; end

%% Test mcrapr with inout algorithm
fprintf('... testing mcrapr with inout ...\n');
% run mcrapr
!./mcrapr ../data/wb-cs.stanford testrun inout _ _ 100

% load the graph and define a pagerank function in terms of alpha
G = bvgraph([datadir filesep 'wb-cs.stanford']);
A = sparse(G);
d = sum(A,2);
[i j v] = find(A);
P = sparse(i,j,v./d(i),size(A,1),size(A,2));
n = size(P,1);
pr1 = @(a) (speye(n)-a*P')\ones(n,1)./n;
norm1 = @(x) x./norm(x,1);
pr = @(a) norm1(pr1(a));

% compute everything in Matlab
alphas = load('testrun.alphas');
Xs = zeros(size(P,1),length(alphas));
for i=1:length(alphas), Xs(:,i) = pr(alphas(i)); end

% load the answers
m2 = binload('testrun.mean');
std2 = binload('testrun.std');

% compute the difference
fprintf('1-norm diffence in mean for c/matlab: %g\n', norm(m2 - mean(Xs,2),1));
fprintf('1-norm diffence in  std for c/matlab: %g\n', norm(std2 - std(Xs,0,2),1));

%% Test mcrapr with power method
fprintf('... testing mcrapr with power ...\n');
% run mcrapr
!./mcrapr ../data/wb-cs.stanford testrun power _ _ 100

% load the graph and define a pagerank function in terms of alpha
G = bvgraph('../data/wb-cs.stanford');
A = sparse(G);
d = sum(A,2);
[i j v] = find(A);
P = sparse(i,j,v./d(i),size(A,1),size(A,2));
n = size(P,1);
pr1 = @(a) (speye(n)-a*P')\ones(n,1)./n;
norm1 = @(x) x./norm(x,1);
pr = @(a) norm1(pr1(a));

% compute everything in Matlab
alphas = load('testrun.alphas');
Xs = zeros(size(P,1),length(alphas));
for i=1:length(alphas), Xs(:,i) = pr(alphas(i)); end

% load the answers
m2 = binload('testrun.mean');
std2 = binload('testrun.std');

% compute the difference
fprintf('1-norm diffence in mean for c/matlab: %g\n', norm(m2 - mean(Xs,2),1));
fprintf('1-norm diffence in  std for c/matlab: %g\n', norm(std2 - std(Xs,0,2),1));


