%% Test the pcerapr_beta C++ code


%% Setup the computation
cwd=pwd; if ~strcmp(cwd(end-5:end),'libbvg'), warning('run from libbvg?'); end
addpath('../matlab'); % add path to the pcerapr function in Matlab
global datadir;
if isempty(datadir), datadir='../data'; end

%% Compute with pcerapr_beta
G = bvgraph([datadir filesep 'example-small']);
P = ssbvgraph(G);
!./pcerapr_beta ../data/example-small 4 test _ _ _ 1 1 0 1
cex = binload('test.mean');
cstdx = binload('test.std');
[ex stdx] = pcerapr(P,4,alphadist('beta',1, 1, 0, 1));
if norm(cex-ex,1) > 1e-10, error('pcerapr_beta not correct for beta(1,1,0,1)'), end;
if norm(cstdx-stdx,1) > 1e-10, error('pcerapr_beta not correct for beta(1,1,0,1)'), end;