function m=unif_moments(N,l,r)
% UNIF_MOMENTS Generate moments of the uniform distribution on r,l
%
% m=unif_moments(N,l,r) generates the 0,...,N moments of the uniform 
% distribution on [l,r].
%
% See also BETA_MOMENTS
%
% Example:
%   m=unif_moments(10,0.4,0.6);      % Moments of unif(0.4,0.6)
%   mb=beta_moments(10,0,0,0.4,0.6); % Moments of unif(0.4,0.6) from beta(0,0)

% David Gleich and Paul Constantine
% Copyright, Stanford University, 2008

% 2008 February 1
% Initial version
%
% 11 February 2008
% Removed p power

m = zeros(N+1,1);
k = 0; ui = 1; nri = 1;

m(1) = ui; % compute and update the moments iteratively
for i=1:N, nri = (i./(i+1))*r*nri; ui = (i./(i+1))*l*ui + nri; m(i+1)=ui; end