function xw = unif_qrule(N,r,l)
% UNIF_QRULE Computes the Gauss Quadrature rule for a uniform disribution
% 
% xw = unif_qrule(N,r,l) generates the N-point Gauss quadrature rule for a 
% uniform distribution on [r,l] via the Jacobi polynomials.
%
% The quadrature points are xw(:,1) and the quadrature weights are xw(:,2).
% This function just calls beta_qrule with a=b=0.
%
% See also BETA_QRULE
%
% Example:
%   xwu=unif_qrule(5,0,1)
%   xwb=beta_qrule(5,0,0,0,1)
%   xwu-xwb

xw=beta_qrule(N,0,0,r,l);