/*               
 * Portions copyright (c) 2003-2007, Paolo Boldi and Sebastiano Vigna. Translation copyright (c) 2007, Jacob Ratkiewicz
 *
 *  This program is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 */

#include "../input_bitstream.hpp"
#include <cassert>
#include <iostream>
#include <vector>
#include <boost/shared_ptr.hpp>

using namespace std;

/**
 * Test harness for input bitstream
 */
int main( int argc, char** argv ) {
    if( argc < 2 ) {
        cerr << "usage: " << argv[0] << " <input-file>\n"
             << "where input file was generated by the obs test harness with identical log.\n";
    }

    webgraph::ibitstream ibs( argv[1] );

   // Call a bunch of methods.
assert( 5 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 44 == ibs.read_zeta( 5 ) );
assert( 15 == ibs.read_zeta( 5 ) );
assert( 33 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 12 == ibs.read_zeta( 5 ) );
assert( 1 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 168 == ibs.read_zeta( 5 ) );
assert( 12 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 6 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 19 == ibs.read_zeta( 5 ) );
assert( 7 == ibs.read_zeta( 5 ) );
assert( 7 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 17 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 14 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 17 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 8 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 1 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 1 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 16 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 11 == ibs.read_zeta( 5 ) );
assert( 16 == ibs.read_zeta( 5 ) );
assert( 1 == ibs.read_zeta( 5 ) );
assert( 11 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 15 == ibs.read_gamma() );
assert( 1 == ibs.read_unary() );
assert( 8 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 3 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 1 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 5 == ibs.read_gamma() );
assert( 0 == ibs.read_gamma() );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 15 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 8 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 3 == ibs.read_zeta( 5 ) );
assert( 28 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 6 == ibs.read_zeta( 5 ) );
assert( 6 == ibs.read_zeta( 5 ) );
assert( 13 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 7 == ibs.read_zeta( 5 ) );
assert( 6 == ibs.read_zeta( 5 ) );
assert( 1 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 5 == ibs.read_zeta( 5 ) );
assert( 0 == ibs.read_zeta( 5 ) );
assert( 32 == ibs.read_zeta( 5 ) );
assert( 2 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 12 == ibs.read_zeta( 5 ) );
assert( 14 == ibs.read_zeta( 5 ) );
assert( 3 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 10 == ibs.read_gamma() );
assert( 0 == ibs.read_unary() );
assert( 0 == ibs.read_gamma() );
assert( 12 == ibs.read_zeta( 5 ) );
assert( 4 == ibs.read_zeta( 5 ) );
assert( 17 == ibs.read_zeta( 5 ) );
    return 0;
}

